#include <Arduino.h>

class Button {
	const unsigned int _debounceDelay = 50;

	unsigned int _pin;
	unsigned long _lastDebounce;
	bool _prevButtonValue, _currentValue;
	void (*_pressCallback)(void);

public:
	Button(int pin, void (*pressCallback)(void)) {
		_pin = pin;
		_pressCallback = pressCallback;
		pinMode(pin, INPUT);
	}

	void loop() {
		bool reading = digitalRead(_pin);

		if (_prevButtonValue != reading) {
			_lastDebounce = millis();
		}

		if (millis() - _lastDebounce > _debounceDelay && reading != _currentValue){
			_currentValue = reading;
			if (_currentValue)
				_pressCallback();
		}

		_prevButtonValue = reading;
	}
};